<template>
  <client-only v-if="pageSettings">
    <carousel v-bind="options">
      <slide
        v-for="(slide, index) in pageSettings.pageSetup.heroSlideshow"
        :key="index"
        class="relative w-full hero sm:overflow-hidden"
      >
        <div class="absolute inset-0">
          <img
            v-lazy="slide.image.mediaItemUrl"
            class="object-cover w-full h-full"
            :alt="slide.image.altText"
          />
        </div>

        <!-- TODO Review if API is null or {} -->
        <!-- TODO When side right and left -->
        <div
          v-if="slide.options"
          class="relative flex items-center justify-end h-full max-w-2xl px-4 sm:px-6 lg:px-32"
        >
          <div class="text-left">
            <h1 class="text-6xl font-light leading-none text-black lg:text-6xl">
              {{ slide.title }}
            </h1>
            <div
              class="max-w-lg mt-6 text-2xl text-black lg:w-10/12 sm:max-w-3xl"
            >
              {{ slide.caption }}
            </div>
            <div class="justify-start max-w-sm mt-10 sm:max-w-none sm:flex">
              <a
                v-if="slide.cta.target === '_blank'"
                class="w-full btn primary large md:w-1/2"
                :href="slide.cta.link"
                :target="slide.cta.target"
              >
                {{ slide.cta.text }}
              </a>
              <nuxt-link
                v-else
                class="w-full btn primary large md:w-1/2"
                :to="slide.cta.link"
                :target="slide.cta.target"
              >
                {{ slide.cta.text }}
              </nuxt-link>
            </div>
          </div>
        </div>
      </slide>
    </carousel>
  </client-only>
</template>

<script>
import getPage from '~/apollo/queries/pages/getPage.gql'

export default {
  data() {
    return {
      options: {
        loop: true,
        perPage: 1,
        autoplay: false,
        autoplayTimeout: 3000,
        navigationEnabled: false,
        paginationEnabled: true,
      },
    }
  },
  apollo: {
    pageSettings: {
      prefetch: true,
      query: getPage,
      variables() {
        return {
          id: this.$route.name === 'index' ? 'home' : this.$route.name,
        }
      },
      update(data) {
        return data.page
      },
    },
  },
}
</script>

<style>
.hero {
  height: 75vh;
}

@media screen and (min-width: 768px) {
  .hero {
    height: 65vh;
  }
}

section#heroBanner > .VueCarousel button.VueCarousel-dot {
  --bg-opacity: 1;

  background: #ccc !important;
  background-color: rgba(204, 204, 204, var(--bg-opacity)) !important;
  height: 0 !important;
  width: 0 !important;
  transition-property: all !important;
  transition-timing-function: cubic-bezier(0.4, 0, 0.2, 1) !important;
  transition-duration: 300ms !important;
  margin-top: 0 !important;
  padding: 8px !important;
}

section#heroBanner
  > .VueCarousel
  button.VueCarousel-dot.VueCarousel-dot--active {
  --bg-opacity: 1;

  background: #f00 !important;
  background-color: rgba(255, 0, 0, var(--bg-opacity)) !important;
  transition-property: all !important;
  transition-timing-function: cubic-bezier(0.4, 0, 0.2, 1) !important;
  transition-duration: 300ms !important;
  margin-top: 0 !important;
  height: 0 !important;
  width: 50px !important;
  border-radius: 1rem !important;
  outline: 2px solid transparent !important;
  outline-offset: 2px !important;
}

section#heroBanner > .VueCarousel button.VueCarousel-dot:focus,
section#heroBanner > .VueCarousel button.VueCarousel-dot:active {
  outline: none !important;
}

section#heroBanner > .VueCarousel button.VueCarousel-dot:hover {
  --bg-opacity: 1;

  background: #fe5454 !important;
  background-color: rgba(254, 84, 84, var(--bg-opacity)) !important;
}

section#heroBanner > .VueCarousel .VueCarousel-dot-container > button {
  margin-left: 10px !important;
}

section#heroBanner
  > .VueCarousel
  .VueCarousel-dot-container
  > button:first-child {
  margin-left: 0 !important;
}
</style>
